program ReadLfn;
(*
**
** Example routines to read a longfilename
**
** Copyright (c) 1999 by Maarten Bekers
**
** Created : 18-Feb-1999
** Last update : 18-Feb-1999
**
** Note: This example program is purely for the purpose of showing how to
**       read an longfilename so it has been kept as simple as possible.
**
*)

{$IFNDEF VirtualPascal}
  Type SmallWord = Word;
{$ENDIF}

type
  FILESHDRrecord = packed record
                     Name           : String[12];
                     Size,
                     CRC32          : LongInt;
                     Uploader       : String[35];
                     UploadDate,
                     FileDate,
                     LastDL         : LongInt;
                     TimesDL        : SmallWord;
                     Attrib         : Byte;
                     PassWord       : String[15];
                     KeyWord        : Array[1..5] of String[15];
                     Cost           : SmallWord;
                     LongDescPtr    : LongInt;
                     LfnPtr         : Longint;
                     FreeSpace      : Array[1..16] of Byte;
                   end;


var Hdr_F  : File of FilesHdrRecord;
    Txt_F  : File;

    HdrInf : FilesHdrRecord;
    TempC  : Char;
    TempStr: String;
begin
  Assign(Hdr_F, 'FDB999.HDR');
  Reset(Hdr_F);

  Assign(Txt_F, 'FDB999.TXT');
  Reset(Txt_F, 1);

  While NOT Eof(Hdr_F) do
    begin
      Read(Hdr_F, HdrInf);

      Writeln('Shortname: ', HdrInf.Name);

      if HdrInf.LfnPtr > 00 then            { 0 was used for RA compatibility }
        begin
          Seek(Txt_F, HdrInf.LfnPtr);

          TempC := #01;
          TempStr := '';

          While TempC <> #00 do
            begin
              BlockRead(Txt_F, TempC, SizeOf(TempC));

              if TempC <> #0 then TempStr := TempStr + TempC;
            end; { while }

          Writeln('Longname : ', TempStr);
        end { if }
          else WriteLn('File has no long name available');

    end; { while }


  Close(Hdr_F);
  Close(Txt_F);
end.
